﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics;
using System.Windows.Forms;
using System.IO;

namespace UpdatezipCreator
{
    class ADB_Access
    {
        public static Process console_global = null; 

        public static string ADB_Path = mainForm.EnvironmentPath;

        public static string ExecuteCommand(string command)
        {
             ProcessStartInfo PSI = new ProcessStartInfo("cmd", "/c " + command);
             PSI.RedirectStandardOutput = true;
             PSI.UseShellExecute = false;
             PSI.CreateNoWindow = true;
             PSI.WorkingDirectory = ADB_Path;

            console_global = Process.Start(PSI);

            string result = console_global.StandardOutput.ReadToEnd();
            return result;
        }

        public static void RunADBServer()
        {

            ProcessStartInfo PSI = new ProcessStartInfo("cmd", "/c adb start-server");
            PSI.UseShellExecute = false;
            PSI.CreateNoWindow = true;
            PSI.WorkingDirectory = ADB_Path;

            Process console = Process.Start(PSI);
            console.WaitForExit();
        }

        public static void KillADBServer()
        {

            ProcessStartInfo PSI = new ProcessStartInfo("cmd", "/c adb kill-server");
            PSI.UseShellExecute = false;
            PSI.CreateNoWindow = true;
            PSI.WorkingDirectory = ADB_Path;

            Process console = Process.Start(PSI);
            console.WaitForExit();
        }

        public static void PullFile(string SourceFile, string OutputFile)
        {

            ExecuteCommand("adb pull \"" + SourceFile + "\" \"" + OutputFile + "\"");
        }

        public static void CPFile(string SourceFile, string OutputFile)
        {
            ExecuteCommand("adb shell cp -r -p \"" + SourceFile + "\" \"" + OutputFile + "\"");
        }

        public static void PushFile(string Source, string Target)
        {
            ExecuteCommand("adb push \"" + Source + "\" \"" + Target + "\"");
        }

        public static void RemoveFile(string Target, bool UpdateLabel)
        {
            string result = ExecuteCommand("adb shell rm \"" + Target + "\"");
            if (result.Contains("directory")) ExecuteCommand("adb shell rmdir \"" + Target + "\"");
        }

        public static bool MountSystemRW()
        {
            string result = ExecuteCommand("adb remount");

            if (!result.Contains("succeeded"))
            {
                MessageBox.Show("Error: access denided! Check if you have a full root kernel.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return false;
            }
            else return true;
        }

        public static void RenameFile(string ItemPath, string OldName, string NewName)
        {

            ExecuteCommand("adb shell mv \"" + ItemPath + "/" + OldName + "\" \"" + ItemPath + "/" + NewName + "\"");
        }

        public static void CreateDirectory(string xPath)
        {

            ExecuteCommand("adb shell mkdir \"" + xPath + "\"");
        }

        public static bool CheckIfDeviceIsConnected()
        {
            string[] Results = ExecuteCommand("adb devices").Split(Char.Parse("\n"));

            int Index = 0;

            for (int i = 0; i < Results.Length; i++)
            {
                if (Results[i].Contains("List of devices"))
                {
                    Index = i + 1;
                    break;
                }
            }

                if (String.IsNullOrWhiteSpace(Results[Index]))
                {
                    MessageBox.Show("Error: no device found! Please connect your phone in Debbuging USB mode.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return false;
                }
                else return true;
        }

        public static bool ItemExists(string xPath)
        {
            string result = ExecuteCommand("adb shell ls -l \"" + xPath + "\"");
            return (!result.Contains("such file or directory") & !result.Contains("Illegal option")) ? true:false;
        }

        public static void Chmod(string permission, string xPath)
        {
            ExecuteCommand("adb shell chmod " + permission + " " + xPath);
        }

        public static void Chown(string permission, string xPath)
        {
            ExecuteCommand("adb shell chown \"" + permission + "\" \"" + xPath + "\"");
        }

        public static void InstallAPK(string xPath, string Flags)
        {
            ExecuteCommand("adb install" + Flags + " \"" + xPath + "\"");
        }

        public static void RebootRecovery()
        {
            ExecuteCommand("adb shell reboot recovery");
        }
    }
}
