﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace UpdatezipCreator
{
    public partial class addForm : Form
    {
        public addForm()
        {
            InitializeComponent();
        }

        private void rbOwn_CheckedChanged(object sender, EventArgs e)
        {
            tbOwnPath.Enabled = rbOwn.Checked;
        }

        public string GetThePath()
        {
            if (rbSystemFramework.Checked) return "system/framework";
            else if (rbSystemApp.Checked) return "system/app";
            else if (rbSystemEtcInitd.Checked) return "system/etc/init.d";
            else if (rbOwn.Checked) return tbOwnPath.Text;
            else return null;
        }

        private void addForm_Load(object sender, EventArgs e)
        {
            tbOwnPath.Text = mainSettings.Default.OwnTargetPath;

            switch (mainSettings.Default.Target)
            {
                case 1:
                    rbSystemFramework.Checked = true;
                    rbOwn.Checked = false;
                    rbSystemApp.Checked = false;
                    rbSystemEtcInitd.Checked = false;
                    break;
                case 2:
                    rbSystemApp.Checked = true;
                    rbOwn.Checked = false;
                    rbSystemFramework.Checked = false;
                    rbSystemEtcInitd.Checked = false;
                    break;
                case 3:
                    rbSystemEtcInitd.Checked = true;
                    rbOwn.Checked = false;
                    rbSystemFramework.Checked = false;
                    rbSystemApp.Checked = false;
                    break;
                case 4:
                    rbOwn.Checked = true;
                    rbSystemFramework.Checked = false;
                    rbSystemApp.Checked = false;
                    rbSystemEtcInitd.Checked = false;
                    break;
            }

            tbOwnPath.Enabled = rbOwn.Checked;
        }

        private void addForm_FormClosed(object sender, FormClosedEventArgs e)
        {
            if (tbOwnPath.Enabled) mainSettings.Default.OwnTargetPath = tbOwnPath.Text;

            if (rbSystemFramework.Checked) mainSettings.Default.Target = 1;
            else if (rbSystemApp.Checked) mainSettings.Default.Target = 2;
            else if (rbSystemEtcInitd.Checked) mainSettings.Default.Target = 3;
            else if (rbOwn.Checked) mainSettings.Default.Target = 4;

            mainSettings.Default.Save();
        }
    }
}
