﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;

namespace UpdatezipCreator
{
    #region ListEntry

    public class scriptFunctionsListEntry
    {
        public string Name;
        public string Function;
        public string Description;
        public string Example;

        public scriptFunctionsListEntry(string Name, string Function, string Description, string Example)
        {
            this.Name = Name;
            this.Function = Function;
            this.Description = Description;
            this.Example = Example;
        }
    }

    #endregion

    #region FunctionXMLList

    public class scriptFunctionsList
    {
        public List<scriptFunctionsListEntry> _List = new List<scriptFunctionsListEntry>();

        public scriptFunctionsList(string _FileName)
        {
            _List.Clear();

            XmlDocument _doc = new XmlDocument();
            _doc.Load(_FileName);

            XmlNodeList _NameList = _doc.GetElementsByTagName("name");
            XmlNodeList _FunctionList = _doc.GetElementsByTagName("function");
            XmlNodeList _DescriptionList = _doc.GetElementsByTagName("description");
            XmlNodeList _ExampleList = _doc.GetElementsByTagName("example");

            for (int i = 0; i < _NameList.Count; i++)
            {
                _List.Add(new scriptFunctionsListEntry(_NameList[i].InnerText,_FunctionList[i].InnerText, _DescriptionList[i].InnerText, _ExampleList[i].InnerText));
            }

        }
    }

    #endregion
}
